.386
.model flat,stdcall
option casemap:none
include odw_.inc

.code
start:
	invoke GetModuleHandle,NULL
	mov    hInstance,eax
	invoke GetCommandLine
	invoke InitCommonControls
	mov		CommandLine,eax
	invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL	wc:WNDCLASSEX
	LOCAL	msg:MSG

	mov		wc.cbSize,sizeof WNDCLASSEX
	mov		wc.style,CS_HREDRAW or CS_VREDRAW
	mov		wc.lpfnWndProc,offset WndProc
	mov		wc.cbClsExtra,NULL
	mov		wc.cbWndExtra,DLGWINDOWEXTRA
	push	hInst
	pop		wc.hInstance
	mov		wc.hbrBackground,COLOR_BTNFACE+1
	mov		wc.lpszMenuName,0
	mov		wc.lpszClassName,offset ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov		wc.hIcon,eax
	mov		wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov		wc.hCursor,eax
	invoke RegisterClassEx,addr wc
	mov ebx,rv(CreateDialogParam,hInstance,IDD_DIALOG,NULL,addr WndProc,NULL)
	invoke ShowWindow,ebx,SW_SHOWNORMAL
	invoke UpdateWindow,ebx
	.while TRUE
		invoke GetMessage,addr msg,NULL,0,0
	  .BREAK .if !eax
		invoke TranslateMessage,addr msg
		invoke DispatchMessage,addr msg
	.endw
	mov		eax,msg.wParam
	ret

WinMain endp

EnumChildProc proc uses ebx esi edi hWnd:HWND,phRgn:ptr HRGN
LOCAL rect[2]:RECT
	
	mov ebx,phRgn
	invoke GetWindowRect,hDlg,ADDR rect[0]
	invoke GetWindowRect,hWnd,ADDR rect[16]
	mov esi,rect[16].left
	mov edi,rect[16].top
	sub esi,rect.left
	sub edi,rect.top
	mov ecx,rect[16].right
	sub ecx,rect[16].left
	mov edx,rect[16].bottom
	sub edx,rect[16].top
	mov rect.left,esi
	mov rect.top,edi
	add esi,ecx
	add edi,edx
	mov rect.right,esi
	mov rect.bottom,edi
	mov esi,rv(CreateRectRgnIndirect,ADDR rect)
	.if HRGN ptr [ebx]
		invoke CombineRgn,HRGN ptr [ebx],HRGN ptr [ebx],esi,RGN_OR
		invoke DeleteObject,esi
	.else
		mov HRGN ptr [ebx],esi
	.endif
	
	mov eax,1
	ret
	
EnumChildProc endp

WndProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL hRgn:HRGN

	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		mov hRgn,0
		m2m hDlg,hWin
		invoke EnumChildWindows,hWin,EnumChildProc,ADDR hRgn
		invoke SetWindowRgn,hWin,hRgn,1
	.elseif eax==WM_COMMAND
		invoke SendMessage,hWin,WM_CLOSE,0,0
	.elseif eax==WM_CLOSE
		invoke DestroyWindow,hWin
	.elseif uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.else
		invoke DefWindowProc,hWin,uMsg,wParam,lParam
		ret
	.endif
	xor    eax,eax
	ret

WndProc endp

end start
